# Bootstrap React Logic

Bootstrap React Logic (BRL) 是一个专为 [React](https://react.dev) 应用设计的逻辑操作库，旨在与 [Bootstrap](https://getbootstrap.com) 样式无缝结合，帮助开发者轻松构建丰富的交互式用户界面

BRL 提供了一系列强大且灵活的逻辑组件，简化了状态管理和事件处理，使得创建动态、响应迅速的 UI 变得更加高效。无论是复杂的表单处理、数据展示还是用户交互，BRL 都能提供流畅的体验，助力开发者快速实现创意设计，提升开发效率

[English](./README.md)

## Installation

Tip：在安装之前请确保已经存在 **bootstrap** 依赖

使用 npm 安装 BRL：

```bash
npm install bootstrap-react-logic
```

## Usage

导入全局样式：`import 'bootstrap-react-logic/dist-lib/bootstrap-react-logic.css'`

导入组件：`import { Button } from 'bootstrap-react-logic'`

基本使用：

```jsx
<Button variant="primary">Primary</Button>
```

## FAQ

Q: 和其他第三方库有什么区别?

- 封装为组件，可以提高复用性和开发效率
- 与其他第三方库相比，该库是根据项目的具体需求而开发的，因此可能并不适合所有用户的需求
- 基于 Bootstrap 的基础上提供更多常用的组件

## License

[MIT](https://opensource.org/licenses/MIT)
