import { ElementType } from 'react';
import { CardProps } from './types.ts';
declare const Card: {
    <T extends ElementType = "div">(props: CardProps<T>): import("react/jsx-runtime").JSX.Element;
    Body: {
        <T extends ElementType = "div">(props: import('./types.ts').CardBodyProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Img: {
        <T extends ElementType = "div" | "img">(props: import('./types.ts').CardImgProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Title: {
        <T extends ElementType = "div">(props: import('./types.ts').CardTitleProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Subtitle: {
        <T extends ElementType = "div">(props: import('./types.ts').CardTitleProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Text: {
        <T extends ElementType = "div">(props: import('./types.ts').CardTextProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Link: {
        <T extends ElementType = "a">(props: import('./types.ts').CardTextProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Header: {
        <T extends ElementType = "div">(props: import('./types.ts').CardTextProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    Footer: {
        <T extends ElementType = "div">(props: import('./types.ts').CardTextProps<T>): import("react/jsx-runtime").JSX.Element;
        displayName: string;
    };
    displayName: string;
};
export default Card;
